<?php

class DBTable
{
	var $tpl; // defaut template
	var $search_engine = false; // pas de moteur de recherche
	var $search_engine_fields = array();
	
	var $dbtable_cols = array();
	
	var $dbtable_add = true;
	var $dbtable_button_view = true;
	var $dbtable_button_edit = true;
	var $dbtable_button_delete = true;
	var $dbtable_button_delete_msg = 'Etes-vous sr de vouloir supprimer cet enregistrement ?';
		
	var $norec_sentence = 'Aucun enregistrement trouv';
	
	var $dbtable_add_uri;				
	var $dbtable_view_uri;
	var $dbtable_edit_uri;
	var $dbtable_delete_uri;

	
	var $dbtable_breaker_name = '';
	function DBTableSetBreaker($dbtable_breaker_name)
	{
		$this->dbtable_breaker_name = $dbtable_breaker_name;
	}
	
	function DBTableDeleteMsg($msg)
	{
		$this->dbtable_button_delete_msg = $msg;
	}

	function SearchEngine($bool)
	{
		$this->search_engine = $bool;
	}
	
	function SearchEngineFields($fields)
	{
		$this->search_engine = true;
		$this->search_engine_fields = $fields;
	}
	
	function DBTableCols($cols)
	{
		$this->dbtable_cols = $cols;
	}
	
	var $dbtable_uri;
	function DBTableUri($uri)	
	{
		$this->dbtable_uri = $uri;
	}
		
	function DBTableGet($sql, $nb=0, $hookdata='')
	{
		$tpl = TPLN_PATH.'/plugin/dbtable/list.html';
		
		// on retire le ajax_bloc
		$uri = $_SERVER['QUERY_STRING'];
		$uri_tmp = explode('&', $uri);
		$str = '';
		foreach($uri_tmp as $r)
		{
			$tmp_arr = explode('=', $r);
			if(count($tmp_arr) == 2)
			{								
				if($tmp_arr[0] != 'ajax_bloc' && $tmp_arr[0] != 't')
				{
					if(!empty($str))$str .= '&';
					$str .= $r;
				}
			}
			else
			{
				if(!empty($str))$str .= '&';
				$str .= $r;	
			}
		}
		$uri_enc = base64_encode($str);
		$this->Open($tpl);
		
		// js function ************************************************************************
		//$this->Parse('func_start', $this->dbtable_js_func_start);
		//$this->Parse('func_end', $this->dbtable_js_func_end);
		
		
		// search engine ******************************************************************************
		if(count($this->search_engine_fields) > 0)
			$this->SearchEngine(true);
			
		if(!$this->search_engine)
		{
			$this->eraseBloc('search_engine');
		}
		else
		{	
			$this->parse('search_engine.uri', $this->dbtable_uri);			
					
			// parsing des champs
			$se_fields = array();
			for($i=0; $i < count($this->search_engine_fields); $i++)
			{
				$field = $this->search_engine_fields[$i];
   			    $field['name'] = $field[0];
				
				if(!isset($field['label']))$field['label'] = $this->_DBTableCaps($field['name']);
				if($field['type'] == 'period')$field['label'] .= ' >='; 
				
				$this->Parse('labels.name', $field['name']);
				$this->Parse('labels.label', $field['label']);
				$this->Parse('labels.type', $field['type']);
				
				$se_fields[] = $field['name'];
				
				if($field['type'] == 'text')
				{
					$this->eraseBloc('labels.date');
					$this->eraseBloc('labels.period');
					$this->eraseBloc('labels.boolean');									
					$this->parse('labels.text.name', $field['name']);
					
					// autocomplete ?
					$this->parse('labels.text.ac.name', $field['name']);
					
					if(isset($field['sql_auto']))
						$field['sql'] = "SELECT DISTINCT {$field['name']} FROM {$field['sql_auto']} WHERE Deleted='NO' AND {$field['name']} != '' ORDER BY {$field['name']}";
					
					
					if(!isset($field['sql']))
					{
						$this->parse('labels.text.ac.datas', '');
					}
					else
					{						
						// on prend les champs sql ?				
						$this->DoQuery($field['sql']);
						$datas = '';
						while($row = $this->DBFetch())
						{
							foreach($row as $key => $val)
							{
								if(!empty($datas))$datas .= ',';
								$datas .= '"'.str_replace('"', '\"', $val).'"';
								break;
							}
						}
						$this->parse('labels.text.ac.datas', $datas);
					}

					$this->loop('labels.text.ac');
					$this->loop('labels.text');
										
				}
				elseif($field['type'] == 'date')
				{
					$this->eraseBloc('labels.text');
					$this->eraseBloc('labels.period');										
					$this->eraseBloc('labels.boolean');														
					$this->parse('labels.date.name', $field['name']);
				}
				elseif($field['type'] == 'period')
				{
					$this->eraseBloc('labels.text');
					$this->eraseBloc('labels.date');
					$this->eraseBloc('labels.boolean');									
										
					$this->eraseBloc('labels.op');
															
					$this->parse('labels.period.name', $field['name']);
				}
				elseif($field['type'] == 'boolean')
				{
					$this->eraseBloc('labels.text');
					$this->eraseBloc('labels.date');
					$this->eraseBloc('labels.period');																	
					$this->eraseBloc('labels.op');
					
					$this->parse('labels.boolean.name', $field['name']);
				}
				
				
				if($field['type'] == 'text' || $field['type'] == 'date' || $field['type'] == 'boolean')
				{
					if(!isset($_GET['SE_'.$field['name']]))$_GET['SE_'.$field['name']] = '';
					$this->Parse('labels.get_val', str_replace('"', '\"', $_GET['SE_'.$field['name']]));
					
					if($field['type'] != 'boolean')
					{
						if(!isset($_GET['SE_'.$field['name'].'_OP']))$_GET['SE_'.$field['name'].'_OP'] = '';
						$this->Parse('labels.op_get_val', str_replace('"', '\"', $_GET['SE_'.$field['name'].'_OP']));
					}
				}
				elseif($field['type'] == 'period')
				{
					if(!isset($_GET['SE_'.$field['name'].'1']))$_GET['SE_'.$field['name'].'1'] = '';
					$this->Parse('labels.get_val1', str_replace('"', '\"', $_GET['SE_'.$field['name'].'1']));

					if(!isset($_GET['SE_'.$field['name'].'2']))$_GET['SE_'.$field['name'].'2'] = '';
					$this->Parse('labels.get_val2', str_replace('"', '\"', $_GET['SE_'.$field['name'].'2']));					
				}
				
				$this->loop('labels');

			}
			
			$se_fields = $this->array2json($se_fields);
			$this->parse('search_engine.se_fields', $se_fields);
			
		}

				
		// dbtable *************************************************************************************
		if(!$this->dbtable_add)
		{
			$this->eraseBloc('add');
		}
		else
		{
			if(empty($this->dbtable_add_uri))$this->dbtable_add_uri = '?mod='.MOD.'&act=form&ID=&popup_mode=1';
			$this->Parse('add_url', $this->dbtable_add_uri);
		}
		
		if(!$this->dbtable_button_view)
		{
			$this->eraseBloc('view_th');
			$this->eraseBloc('view_td');			
		}
		else
		{
			if(empty($this->dbtable_view_uri))$this->dbtable_view_uri = '?mod='.MOD.'&act=view&ID={ID}&popup_mode=1';
			$this->Parse('view_url', $this->dbtable_view_uri);
		}
		
		$order_by_arr = array();
		foreach($this->dbtable_cols as $cols)				
		{
			$cols['name'] = $cols[0];
			
			$cols['noclick'] = 0;
			
			// macro 
			if(isset($cols['macro']))
			{
				if($cols['macro'] == 'ico')
				{
					if(!isset($cols['label']))$cols['label'] = '';
					$cols['align'] = 'center';
					$cols['style'] = 'width:10px;';
					$cols['noclick'] = 1;
				}
				elseif($cols['macro'] == 'image')
				{
					if(!isset($cols['label']))$cols['label'] = '';
					if(!isset($cols['align']))$cols['align'] = 'center';
					if(!isset($cols['style']))$cols['style'] = 'width:10px;';
					$cols['noclick'] = 1;
				}
				elseif($cols['macro'] == 'file')
				{
					if(!isset($cols['label']))$cols['label'] = '';
					if(!isset($cols['align']))$cols['align'] = 'center';
					if(!isset($cols['style']))$cols['style'] = 'width:10px;';
					$cols['noclick'] = 1;
				}
				elseif($cols['macro'] == 'boolean')
				{
					if(!isset($cols['align']))$cols['align'] = 'center';
					if(!isset($cols['style']))$cols['style'] = 'width:10px;';
					$cols['noclick'] = 1;			
				}
				
			}
			
		
			if(!isset($cols['label']))$cols['label'] =  $this->_DBTableCaps($cols['name']);
			$this->Parse('list_fields.label', $cols['label']);
			
			$cols['style'] = (!isset($cols['style'])) ? '' : 'style="'.$cols['style'].'"';				
			$this->Parse('list_fields.style', $cols['style']);
			
			if(!isset($cols['align']))$cols['align'] = 'left';
			$this->Parse('list_fields.align', $cols['align']);
			
			if(!isset($cols['order_by']))$cols['order_by'] = false;
			
			$order_by = '';
			if($cols['order_by'])
			{
				$order_by = '{_order_by::'.$cols['name'].'}';
				$order_by_arr[] = $cols['name'];
				
			}
			$this->Parse('list_fields.order_by', $order_by);			
			$this->loop('list_fields');
			
			if(isset($cols['macro']))
			{
				$str = '';
				if($cols['macro'] == 'ico')
				{
					$str = '<a id="'.$cols['macro_name'].'_{ID}" href="javascript:'.$cols['macro_func'].'">';
					$str .= '<img src="'.TPLN_WEB_PATH.'/plugin/dbtable/img/'.$cols['macro_image'].'" align="absmiddle" />';
					$str .= '</a>';
				}
				elseif($cols['macro'] == 'image')
				{
					$str = '#<img src="'.$cols['path'].'/{ '.$cols['name'].' }" align="absmiddle" />#';
				}
				elseif($cols['macro'] == 'file')
				{
					if(!isset($cols['sqlID'])) $cols['sqlID'] = 'ID';
					$str = '#<a href="'.$cols['path'].'/{ '.$cols['sqlID'].' }.{ '.$cols['name'].' }" target="_blank">
							<img src="'.TPLN_WEB_PATH.'/plugin/dbtable/img/file_{ '.$cols['name'].' }.png" align="absmiddle" />
							</a>#';
				}
				elseif($cols['macro'] == 'boolean')
				{
					$str = '#<img src="'.TPLN_WEB_PATH.'/plugin/dbtable/img/{ '.$cols['name'].' }.gif" align="absmiddle" />#';
				}
				
				$this->Parse('list_cols.name', $str);
			}
			else
			{
				$this->Parse('list_cols.name', $cols['name']);
			}
			
			$this->Parse('list_cols.align', $cols['align']);
			$this->Parse('list_cols.noclick', $cols['noclick']);
			
			$this->loop('list_cols');		
		}		
		
		if(!$this->dbtable_button_edit)
		{
			$this->eraseBloc('edit_th');
			$this->eraseBloc('edit_td');			
		}
		else
		{
			if(empty($this->dbtable_edit_uri))$this->dbtable_edit_uri = '?mod='.MOD.'&act=form&ID={ID}&popup_mode=1&uri_enc='.$uri_enc;
			$this->parse('edit_url', $this->dbtable_edit_uri);
		}
		
		if(!$this->dbtable_button_delete)
		{
			$this->eraseBloc('delete_th');
			$this->eraseBloc('delete_td');
		}
		else
		{
			if(empty($this->dbtable_delete_uri))$this->dbtable_delete_uri = '?mod='.MOD.'&ajax_bloc=DBTable&ajax=1&act=delete&ID={ID}&uri_enc='.$uri_enc;
			$this->parse('delete_url', $this->dbtable_delete_uri);		
			$this->parse('delete_msg', $this->dbtable_button_delete_msg);
		}				
		
		$this->Parse('norec_sentence', $this->norec_sentence);


		$nb_cols = count($this->dbtable_cols);
		
		if($this->dbtable_button_view)$nb_cols++;
		if($this->dbtable_button_edit)$nb_cols++;
		if($this->dbtable_button_delete)$nb_cols++;
		
		// breaker ****************************************************************************************
		if(empty($this->dbtable_breaker_name))
		{
			$this->eraseBloc('breaker_p');
			
		}
		else
		{			
			$this->Parse('breaker_nb_cols', $nb_cols);
			$this->Parse('breaker_name', $this->dbtable_breaker_name);			
		}
				

		// pagination *************************************************************************************		
		$this->Parse('nbcols', $nb_cols);
		$this->Parse('dbtable_image_src', TPLN_WEB_PATH.'/plugin/dbtable/img');		
		
		$out = $this->Output();

		
		$out = str_replace('{ ', '{', $out);
		$out = str_replace(' }', '}', $out);
		
		$out = str_replace('{#', '', $out);
		$out = str_replace('#}', '', $out);
				
		$out = str_replace('< ', '<', $out);
		
		// marco ico
		$out = str_replace('{<a ', '<a ', $out);
		$out = str_replace('</a>}', '</a>', $out);

		// echo "$out<hr />";
		
		// sql dynamque *************************************************************************************
		$sql_added = '';		
		for($i=0; $i < count($this->search_engine_fields); $i++)
		{
			$field = $this->search_engine_fields[$i][0];
			$type = $this->search_engine_fields[$i]['type'];
			
			$add_to_uri = false;
			$add_to_uri1 = false;
			$add_to_uri2 = false;			
								
			// text verification ***********************************************************
			if($type == 'text')			
			{				
				if( 
					isset($_GET['SE_'.$field.'_OP']) && !empty($_GET['SE_'.$field.'_OP']) && 
					isset($_GET['SE_'.$field]) && !empty($_GET['SE_'.$field])				
				  )
				{
					$add_to_uri = true;
					$v = mysql_real_escape_string(urldecode($_GET['SE_'.$field]));
																					
					if(in_array($_GET['SE_'.$field.'_OP'], array('=','!=','<','<=','>','>=')))
					{
						$sql_added .= ' AND '.$field.' '.$_GET['SE_'.$field.'_OP']." '".$v."' \n";
					}
					elseif(in_array($_GET['SE_'.$field.'_OP'], array('like','not_like')))				
					{					
						$v = str_replace('%', '', $v);
						$v = str_replace('_', '', $v);
					
						$op = ($_GET['SE_'.$field.'_OP'] == 'like') ? 'LIKE' : 'NOT LIKE';
						$sql_added .= ' AND '.$field.' '.$_GET['SE_'.$field.'_OP']." '".$v."%' \n";					
					}
					else
					{
						$add_to_uri = false;
					}
				}
			}
			// boolean verification ***********************************************************
			if($type == 'boolean')			
			{				
				if( 
					isset($_GET['SE_'.$field]) && !empty($_GET['SE_'.$field]) && in_array($_GET['SE_'.$field], array('OUI', 'NON'))				
				  )
				{
					$add_to_uri = true;
					$v = mysql_real_escape_string(urldecode($_GET['SE_'.$field]));
					$sql_added .= " AND ".$field." = '".$v."' \n";
				}					
			}			
			// date verification ***********************************************************
			elseif($type == 'date')			
			{
				if( 
					isset($_GET['SE_'.$field.'_OP']) && !empty($_GET['SE_'.$field.'_OP']) && 
					isset($_GET['SE_'.$field]) && !empty($_GET['SE_'.$field]) && 
					eregi('^([0-9]{2})/([0-9]{2})/([0-9]{4})$', $_GET['SE_'.$field])
				  )
				{
					$add_to_uri = true;
					$v = mysql_real_escape_string($_GET['SE_'.$field]);
					$v = ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4})$', '\3-\2-\1', $v); 
																									
					if(!in_array($_GET['SE_'.$field.'_OP'], array('=','!=','<','<=','>','>=')))
					{
						$add_to_uri = false;
					}
					else
					{
						$sql_added .= ' AND '.$field.' '.$_GET['SE_'.$field.'_OP']." '".$v."' \n";
					}
				}				
			}
			// period verification ***********************************************************				
			elseif($type == 'period')			
			{
				// date 1
				if( 
					isset($_GET['SE_'.$field.'1']) && !empty($_GET['SE_'.$field.'1']) && 
					eregi('^([0-9]{2})/([0-9]{2})/([0-9]{4})$', $_GET['SE_'.$field.'1'])
				  )
				{
					$add_to_uri = true;
					$add_to_uri1 = true;
					$v = mysql_real_escape_string($_GET['SE_'.$field.'1']);
					$v = ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4})$', '\3-\2-\1', $v); 																									
					$sql_added .= ' AND '.$field.' >= '." '".$v."' \n";
				}
				
				// date 2
				if( 
					isset($_GET['SE_'.$field.'2']) && !empty($_GET['SE_'.$field.'2']) && 
					eregi('^([0-9]{2})/([0-9]{2})/([0-9]{4})$', $_GET['SE_'.$field.'2'])
				  )
				{
					$add_to_uri = true;
					$add_to_uri2 = true;					
					$v = mysql_real_escape_string($_GET['SE_'.$field.'2']);
					$v = ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4})$', '\3-\2-\1', $v); 																									
					$sql_added .= ' AND '.$field.' <= '." '".$v."' \n";
				}				
				
			}
				
			// on ajoute le champs dans la recherche
			if($add_to_uri)
			{
				if($type != 'period')
				{
					if($type != 'boolean')$this->dbtable_uri .= '&SE_'.$field.'_OP='.urlencode($_GET['SE_'.$field.'_OP']);				
					$this->dbtable_uri .= '&SE_'.$field.'='.urlencode($_GET['SE_'.$field]);
				}
				else
				{
					if($add_to_uri1)$this->dbtable_uri .= '&SE_'.$field.'1='.urlencode($_GET['SE_'.$field.'1']);
					if($add_to_uri2)$this->dbtable_uri .= '&SE_'.$field.'2='.urlencode($_GET['SE_'.$field.'2']);
				}
			}
		}
		
		$this->urlAddvar($this->dbtable_uri);
		$sql = str_replace('[SEARCH_ENGINE]', $sql_added, $sql);
		

		if(count($order_by_arr) > 0)
			$this->ShowrecordsOrderBy($order_by_arr);		
		
		$this->CreateVirtualTemplate($out);
		$this->ShowRecords($sql, $nb, $hookdata);
		$out = $this->Output();
		
		return $out;
	}
	
	
	function DBTableView($title, $sql, $row2_data='', $func_data='')
	{
		$tpl = TPLN_PATH.'/plugin/dbtable/view.html';
		$this->Open($tpl);
		
		$this->Parse('title', $title);
		
		$this->DoQuery($sql);
		$row = $this->DBFetch();
		
		// methode ?
		if(!empty($row2_data))
		{
			if(strpos($row2_data, '::') !== false || strpos($row2_data, '->') !== false) // methode ?
				eval("\$row = $row2_data(\$row);");
			else
				$row = $row2_data($row);   
		}		
		
			
		$f = array();
		foreach($row as $key => $val)
		{
			$val = eregi_replace("([_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)+)",
                       "<a href=\"mailto:\\1\">\\1</a>", $val);
			$val = eregi_replace("([[:alnum:]]+)://([^[:space:]]*)([[:alnum:]#?/&=])",
						"<a href=\"\\1://\\2\\3\" target=\"_blank\">\\1://\\2\\3</a>", $val);
		
			$tmp = array();
			
						
			if(!empty($key) && $key[0] != '_')
			{
				$tmp['name'] = $key;
				
				if($tmp['name'] == 'Note')
					$tmp['value'] = nl2br($val);
				else
					$tmp['value'] = $val;
				
				
				
				// image ?
				if($val == 'OUI' || $val == 'NON')	
				{
					$tmp['value'] = '<img src="img/'.$val.'.gif" align="absmiddle" />';
				}
				
				if($key != 'Deleted')
				{
					$f[] = $tmp;
				}
			}
		}
		
		
		$i = 0;
		foreach($f as $field)
		{			
			// on applique le formatage
			$field['label'] = $this->_DBTableCaps($field['name']);			

			// methode ?
			if(!empty($func_data))
			{
				if(strpos($func_data, '::') !== false || strpos($func_data, '->') !== false) // methode ?
					eval("\$field = $func_data(\$field);");
				else
					$field = $func_data($field);   
			}							

			
			$this->Parse('fields.label', $field['label']);
			$field['value'] = $this->clickable($field['value']);
			$this->Parse('fields.value', $field['value']);
			
			
			// navcolor
			if($this->ItemExists('_NavColor', 'fields'))
			{
				$color = ($i % 2) ? TPLN_DB_NavColorFirst : TPLN_DB_NavColorSecond;
				$this->Parse('fields._NavColor', $color);
			}
			
			$this->Loop('fields');
			$i++;
		}
				
		$out = $this->Output();
		return $out;		
	}
	
	
	var $dbtable_form_valid_create = 'Votre enregistrement a bien t cr';
	var $dbtable_form_valid_update = 'Votre enregistrement a bien t modifi';
	var $dbtable_form_fields = array();
	function DBTableForm($fields, $form_action='')
	{	
		$this->dbtable_form_fields = $fields;
		
		$this->FormSetlang('fr');
		$this->formSetDisplayMode('T');
			
		$tpl = TPLN_PATH.'/plugin/dbtable/form.html';
		$this->Open($tpl);
		
		// on parse la target
		if(empty($form_action))
		{
			if(!isset($_GET['uri_enc']))
				$_GET['uri_enc'] = base64_encode('?mod='.MOD);
			
			$form_action = '?mod='.MOD.'&act=form&ID='.$_GET['ID'].'&url_enc='; // .$_GET['uri_enc'];
		}
		$form_action .= '&popup_mode=1&&ajax=1&ajax_bloc=form&t='.time();
		
		$this->parse('form_action', $form_action);
		//$this->parse('uri_dec', $_GET['uri_enc'], '|base64_decode');
		
		$title = ($_GET['ID'] == 0) ? "Ajout d'un enregistrement" : "Modification de l'enregistrement #{$_GET['ID']}";		
		$this->parse('title', $title);
		
		// $GLOBALS['_NAVBAR'][] = array($title, $form_action);
		
		$types = array('text','file', 'image', 'date', 'datetime', 'select', 'auto_complete', 'memo', 'boolean', 'textarea', 'fieldset', 'fieldset_end');
		foreach($fields as $f)
		{			
			$f['name'] = $f[0];
			
			if($f['type'] != 'hidden')
			{
				// label
				if(!isset($f['label']))$f['label'] = $this->_DBTableCaps($f['name']);
				$this->parse('fields.td_label.label', $f['label']);
				$this->parse('fields.td_label.name', $f['name']);						
				
				// required
				if(!isset($f['required']))$f['required'] = false;
				if(!$f['required'])
					$this->eraseBloc('fields.td_label.required');
				// xtra
				if($f['type'] != 'fieldset_end')
				{
					if(!isset($f['xtra']))$f['xtra'] = '';
					$this->Parse('fields.'.$f['type'].'.xtra', $f['xtra']);
				
					$this->Parse('fields.'.$f['type'].'.name', $f['name']);
				}
				// value
				if($f['type'] != 'fieldset' && $f['type'] != 'fieldset_end' &&  $f['type'] != 'image' &&  $f['type'] != 'file')
				{
					if(!isset($f['value']))$f['value'] = '';
					$this->Parse('fields.'.$f['type'].'.value', $f['value']);
				}
				// style
				if($f['type'] != 'fieldset_end')
				{				
					if(!isset($f['style']))$f['style'] = '';
					$this->Parse('fields.'.$f['type'].'.style', $f['style']);				

					if(!isset($f['label_after']))$f['label_after'] = '';
					$this->Parse('fields.'.$f['type'].'.label_after', $f['label_after']);
				}

				
									
				
				/** text ***************************************************************/
				if($f['type'] == 'text')
				{				

				}
				/** file ***************************************************************/
				elseif($f['type'] == 'file')
				{
					if($_GET['ID'] == 0)
					{
						$TPLN->eraseBloc('fields.file.desc');
					}
					else
					{													
						
						// on capture le ficheir
						$this->DoQuery("SELECT {$f['name']} FROM $this->dbtable_sql_table  WHERE ID = {$_GET['ID']}");
						$res = $this->GetOne();
						if(empty($res))
						{
							$this->eraseBloc('fields.file.desc');
						}
						else
						{
							$this->parse('fields.file.desc.path', $f['path']);
							$this->parse('fields.file.desc.fname', $_GET['ID'].'.'.$res);
							
							$ext = explode('.', $res);
							$ext = $ext[count($ext)-1];
							$this->parse('fields.file.desc.iname', $ext);
														
						}					
						$this->loop('fields.file.desc');
						$this->loop('fields.file');
					}	
				}
				/** image ***************************************************************/
				elseif($f['type'] == 'image')
				{
					$this->Parse('fields.image.path', $f['path']);
					
					if($_GET['ID'] == 0)
					{
						$this->Parse('fields.image.iname', $f['default']);
					}
					else
					{							
						// on capture l'image
						$this->DoQuery("SELECT {$f['name']} FROM $this->dbtable_sql_table  WHERE ID = {$_GET['ID']}");
						$res = $this->GetOne();
						if(empty($res))
							$image = $f['default'];
						else
							$image = $res;
						
						$this->Parse('fields.image.iname', $image);
					}	
				}
				/** boolean ***************************************************************/
				elseif($f['type'] == 'boolean')
				{				
					if(!isset($f['selected']))$f['selected'] = 'YES';
					if($f['selected'] == 'YES')	
					{
						$this->parse('fields.boolean.yes_selected', 'selected');
						$this->parse('fields.boolean.no_selected', '');						
					}
					else
					{
						$this->parse('fields.boolean.yes_selected', '');
						$this->parse('fields.boolean.no_selected', 'selected');					
					}
				}			
				/** date ***************************************************************/
				elseif($f['type'] == 'date')
				{				

				}
				/** datetime ***************************************************************/
				elseif($f['type'] == 'datetime')
				{				

				}	
				/** textarea ***************************************************************/
				elseif($f['type'] == 'textarea')
				{				

				}									
				/** auto_complete ***************************************************************/
				elseif($f['type'] == 'auto_complete')
				{									
					if(isset($f['sql_auto']))
						$f['sql'] = "SELECT DISTINCT {$f['name']} FROM {$f['sql_auto']} WHERE {$f['name']} != '' ORDER BY {$f['name']}";
					
					// on prend les champs sql ?
					$this->DoQuery($f['sql']);
					
					
					$datas = '';
					while($row = $this->DBFetch())
					{
						foreach($row as $key => $val)
						{
							if(!empty($datas))$datas .= ',';
							$datas .= '"'.str_replace('"', '\"', $val).'"';
							break;
						}
					}				
					$this->Parse('fields.auto_complete.datas', $datas);
				}
				/** select ***************************************************************/
				elseif($f['type'] == 'select')
				{							
					if(isset($f['sql_fk']))
					{
						$f['options'][] = array('label' => '', 'value' => '');
						
						$sql = "SELECT DISTINCT {$f['sql_fk']} AS label, ID AS value FROM ".str_replace('ID', '', $f['name'])." WHERE Deleted = 'NO' ORDER BY {$f['sql_fk']}";
						$this->DoQuery($sql);
						while($row = $this->DBFetch())
						{
							$f['options'][] = array('label' => $row['label'], 'value' => $row['value']);
						}
					}
					if(isset($f['sql']))
					{
						$f['options'][] = array('label' => '', 'value' => '');
						$this->DoQuery($f['sql']);
						while($row = $this->DBFetch())
						{
							$f['options'][] = array('label' => $row['label'], 'value' => $row['value']);
						}						
					}
					
					foreach($f['options'] as $opt)
					{
						if(!isset($opt['label']))$opt['label'] = $opt['value'];
						$this->parse('fields.select.options.label', $opt['label']);
						$this->parse('fields.select.options.value', $opt['value']);	
						$this->loop('fields.select.options');				
					}
					$this->loop('fields.select');
				}
				/** memo ***************************************************************/
				elseif($f['type'] == 'memo')	
				{
					$this->erasebloc('fields.td_label');
					$this->parse('fields.memo.label', $f['label']);					
				}
				/** fieldset ***************************************************************/
				elseif($f['type'] == 'fieldset')
				{				
					$this->erasebloc('fields.td_label');
					$this->parse('fields.fieldset.label', $f['label']);					
				}
				/** fieldset end ***************************************************************/
				elseif($f['type'] == 'fieldset_end')
				{
					$this->erasebloc('fields.td_label');
				}
				
				
				
				foreach($types as $t)
				{
					if($f['type'] != 'hidden' && $t != $f['type'])
					{
						$this->EraseBloc('fields.'.$t);
					}
					//$this->Loop('fields.'.$t);
				}
				
				//$this->Loop('fields.required');
				$this->Loop('fields.td_label');
				$this->Loop('fields');
			}
		}
		
		
		// pas d'enregistrement nouveau
		if($_GET['ID'] == 0)
			$this->eraseBloc('insert_new');
			
		// on regarde les champs cachs **************************************
		$hidden_fields = array();
		foreach($fields as $f)
		{
			if($f['type'] == 'hidden')
			{
				if(!isset($f['value']))$f['value'] = '';
				$hidden_fields[] = array('name' => $f['name'], 'value' => $f['value']);
			}
		}		
		$this->loadArrayInBloc('hidden_fields', $hidden_fields);
		
			
		// mask sur les champs ************************************************
		$masks = array();
		foreach($fields as $f)
		{
			$f['name'] = $f[0];
			if(isset($f['mask']) && !empty($f['mask']))
			{
				$masks[] = array('name' => $f['name'], 'mask' => $f['mask']);
			}
		}
		$this->LoadArrayInBloc('masks', $masks);
		
		// helper sur les champs ************************************************
		$helpers = array();
		foreach($fields as $f)
		{
			$f['name'] = $f[0];
			if(isset($f['help']) && !empty($f['help']))
			{
				$helpers[] = array('name' => $f['name'], 'type' => $f['type'], 'help' => $f['help']);
			}
		}
		$this->LoadArrayInBloc('helpers', $helpers);		
		
		
		// form valid *************************************************************
		if($_GET['ID'] == 0 || (isset($_POST['x_insert_as_new']) && $_POST['x_insert_as_new'] == 1))
		{
			$this->Parse('form_valid_msg', $this->dbtable_form_valid_create);
		}
		else
		{
			$this->Parse('form_valid_msg', $this->dbtable_form_valid_update);
		}
		
		// inclusion des js ***************************************************
		$js_files = glob(MOD_PATH.'/*.js');
		if(count($js_files) == 0)
			$this->EraseBloc('form_js');
		else
		{
			foreach($js_files as $js_file)
			{
				$this->Parse('form_js.file', file_get_contents($js_file));
				$this->Loop('form_js');
			}
		}
		
		// validation des champs ************************************************
		$out = $this->Output();	
		
		$out = str_replace('< bloc::', '<bloc::', $out);
		$out = str_replace('< /bloc::', '</bloc::', $out);	
	
		
		$this->createVirtualTemplate($out);		
		
		
		if($_GET['ID'] != 0)
		{
			$this->DoQuery("SELECT * FROM $this->dbtable_sql_table WHERE ID = {$_GET['ID']}");
			$row = $this->DBFetch();
			
			// modification des dates directement
			foreach($row as $key => $val)
			{
				if(ereg('^Date', $key))
				{
					// date time ?
					if(ereg('^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})$', $val))
					{
						$row[$key] = ereg_replace('^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})$', '\3/\2/\1 \4:\5', $val);
					}
					// date ?
					else
					{
						$row[$key] = ereg_replace('^([0-9]{4})-([0-9]{2})-([0-9]{2})$', '\3/\2/\1', $val);							
					}
				}
			}
			
						
			// on ajoute ou pas une requte 
			if(!empty($this->fields_added_sql))
			{
				$this->DoQuery($this->fields_added_sql);
				$row2 = $this->DBFetch();
				$row = array_merge($row, $row2);
			}
			
			
			$this->formInit($row);
		}
		
		
		foreach($fields as $f)
		{
			$f['name'] = $f[0];
			if(isset($f['required']) && $f['required'])
			{
				$this->NotEmpty($f['name']);
			}
			
			// Date
			if($f['type'] == 'date')
				$this->isDate($f['name'], 'd/m/Y');
				
			// Datetime
			if($f['type'] == 'datetime')
				$this->isDate($f['name'], 'd/m/Y H:i');
			
			// Email
			if($f['name'] == 'Email' || 
			   (isset($f['validation']) && in_array('Email', explode('|', $f['validation'])))
			   )
				$this->Email($f['name']);
				
			// Image
			if($f['type'] == 'image')
			{
				if(!isset($f['max_size']))$f['max_size'] = '';
				if(!isset($f['mimes']))$f['mimes'] = '';
				if(!isset($f['ext']))$f['ext'] = '';
				
				$rec = (isset($f['required'])) ? true : false;
				$this->fileControl($f['name'], $rec, $f['max_size'], $f['mimes'], $f['ext']);

				if(isset($f['min_width']))$this->imgControlWidth($f['name'], '>=', $f['min_width']);
				if(isset($f['max_width']))$this->imgControlWidth($f['name'], '<=', $f['max_width']);
								
				if(isset($f['min_heigth']))$this->imgControlHeight($f['name'], '>=', $f['min_heigth']);								
				if(isset($f['max_heigth']))$this->imgControlHeight($f['name'], '<=', $f['max_heigth']);
			}
			
			
			// File
			if($f['type'] == 'file')
			{
				if(!isset($f['max_size']))$f['max_size'] = '';
				if(!isset($f['mimes']))$f['mimes'] = '';
				if(!isset($f['ext']))$f['ext'] = '';
				
				$rec = (isset($f['required'])) ? true : false;
				$this->fileControl($f['name'], $rec, $f['max_size'], $f['mimes'], $f['ext']);				
			}			
			
		}
				
		// ajout des rgles perso
		if($_POST && file_exists(MOD_PATH.'/form.rules.inc.php'))		
		{
			include_once(MOD_PATH.'/form.rules.inc.php');
		}
			
	}
	var $dbtable_sql_table = '';
	var $fields_added_sql = '';	
	function DBTableFormInit($dbtable_sql_table, $fields_added_sql='')
	{
		$_GET['popup_mode'] = true;
		$this->dbtable_sql_table = $dbtable_sql_table;
		
		if(!isset($_GET['ID']))$_GET['ID'] = 0;
		$_GET['ID'] = (int) $_GET['ID'];
		$MODE = ($_GET['ID'] == 0) ? 'add' : 'edit';

		$this->fields_added_sql = str_replace('[ID]', $_GET['ID'], $fields_added_sql);
	}
	
	
	function DBTableFormExecute($added_fields = array())
	{
		$fields = array();
		foreach($this->dbtable_form_fields as $f)
		{
			$tmp = array();
			
			$f['name'] = $f[0];
			if(!empty($f['name']) && $f['type'] != 'image'  && $f['type'] != 'fieldset' && $f['type'] != 'fieldset_end' && !isset($f['sql_exclude']))
			{
				$str = $_POST[$f['name']];
				if($f['type'] == 'date')
				{
					if(!empty($str))
						$str = ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4})$', '\3-\2-\1', $str);
				}
				if($f['type'] == 'datetime')
				{
					if(!empty($str))
						$str = ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4}) ([0-9]{2}):([0-9]{2})$', '\3-\2-\1 \4:\5:00', $str);			
				}
				$fields[$f['name']] = $str;
			}
		}
		
		foreach($added_fields as $adf)
		{
			if(isset($_POST[$adf]))
				$fields[$adf] = $_POST[$adf];
		}

		$curID = 0;
		// $this->DoQuery("LOCK TABLES $this->dbtable_sql_table WRITE");
		if($_GET['ID'] == 0 || (isset($_POST['x_insert_as_new']) && $_POST['x_insert_as_new'] == 1))
		{
			// on gnre la requte insertion
			$this->DBInsert($this->dbtable_sql_table, $fields);			
			$this->DoQuery("SELECT MAX(ID) FROM $this->dbtable_sql_table");
			$curID = (int)$this->getOne();			
			
			if(file_exists(MOD_PATH.'/form.add.inc.php'))
				include(MOD_PATH.'/form.add.inc.php');			
		}
		else
		{
			$curID = $_GET['ID'];
			$this->DBUpdate($this->dbtable_sql_table, $fields, 'ID='.$_GET['ID']);
			if(file_exists(MOD_PATH.'/form.update.inc.php'))
				include(MOD_PATH.'/form.update.inc.php');					
		}		
		//$this->DoQuery("UNLOCK TABLES");
		
		// upload des fichiers
		foreach($this->dbtable_form_fields as $f)
		{
			if($f['type'] == 'image' || $f['type'] == 'file')
			{
				$f['name'] = $f[0];
				if(isset($_FILES[$f['name']]) && is_uploaded_file($_FILES[$f['name']]['tmp_name']))
				{
					$file_name = $_FILES[$f['name']]['name'];
					$ext = explode('.', $file_name);
					$ext = $ext[count($ext)-1];
					$ext = strtolower($ext);
					$new_name = $curID.'.'.trim($ext);
					@unlink($f['path'].'/'.$new_name);
					move_uploaded_file($_FILES[$f['name']]['tmp_name'], $f['path'].'/'.$new_name);
					
					if($f['type'] == 'file')$new_name = $ext;
										
					$this->DBUpdate($this->dbtable_sql_table, array("{$f['name']}" => $new_name), 'ID='.$curID);
				}
				else
				{
					if($f['type'] == 'image')
						$this->DBUpdate($this->dbtable_sql_table, array("{$f['name']}" => $f['default']), 'ID='.$curID);
				}
			}
		}
		
		return $curID;
	}
	
	function DBTableDelete($table, $redirect = '', $files_inc = array())
	{		
		if(!isset($_GET['ID']))$_GET['ID'] = 0;
		$_GET['ID'] = (int) $_GET['ID'];
		
		
		//$this->DoQuery("LOCK TABLES $table WRITE");
		$this->DBUpdate($table, array('Deleted' => 'YES'), "ID={$_GET['ID']}");
		
		// inclusion de fichiers
		foreach($files_inc as $f)
			include_once($f);
		//$this->DoQuery("UNLOCK TABLES");
				
		// redirection
		//$t = time();
		$this->redirect('?mod='.MOD.'&act=list&ajax=1&ajax_bloc=DBTable&'.base64_decode($_GET['uri_enc']));
	}
	
	function _DBTableCaps($str)
	{
		$caps = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
		$caps2 = array(' A',' B',' C',' D',' E',' F',' G',' H',' I',' J',' K',' L',' M',' N',' O',' P',' Q',' R',' S',' T',' U',' V',' W',' X',' Y',' Z');				
		
		$str = str_replace($caps, $caps2, $str);		
		$str = trim(str_replace('  ',' ',$str));
		
		$str = str_replace(' I D', 'ID', $str);
		if($str == 'I D')$str = 'ID';
		
		return $str;
	}

}

?>