// JavaScript Document
function redirect(uri)
{
	document.location.href = uri;	
}


function sys_goto(uri, target)
{	
	// uri externe ?
	var v = new RegExp();
    v.compile("^[A-Za-z]+://[A-Za-z0-9-_]+\\.[A-Za-z0-9-_%&\?\/.=]+$");
    if(v.test(uri))
	{
		w = 800;
		h = 600;
		var top = (screen.height - h) / 2;
		var left = (screen.width - w) / 2; 

		opts = 'toolbar=no';
		opts += ',resizable=yes';		
		opts += ',top='+top;
		opts += ',left='+left;
		opts += ',width='+w;
		opts += ',height='+h;
		
		window.open(uri, '', opts);
		return;
	}

	pos = $('div#'+target).position();
	
	margin_top = $('div#'+target).css('margin-top');
	if(margin_top > 0)
		pos.top += parseInt(margin_top);
		
	margin_left = $('div#'+target).css('margin-left');
	if(margin_left > 0)
		pos.left += parseInt(margin_left);
	
	b_top = $('div#'+target).css('border-top-width');
	pos.top += parseInt(b_top);	
	b_left = $('div#'+target).css('border-left-width');
	pos.left += parseInt(b_left);		
	
	$('#ajax_loader').css({top:pos.top+'px', left:pos.left+'px'});
	$('div#'+target).fadeTo(0, 0.9);
	$("#ajax_loader").show();
	
	uri = uri+'&ajax_bloc='+target+'&t='+Math.random();	
	$('div#'+target).load(uri, null, function() {													
													// resizer('ONLY_MAIN');													
											   		$("#ajax_loader").hide();
													$('div#'+target).fadeTo(0.9, 1);													
											   });
}


function tt_view_close()
{
	$("#tt_canvas").hide();
	$("#tt").hide();
	$('#tt_frame').attr('url', '');
	$('#tt_frame').attr('open', 0);	
}

function tt_view(uri, parentID, w, h)
{
	if($('#tt_frame').attr('open') == 1 && $('#tt_frame').attr('url') == uri)
	{
		tt_view_close();
		return;
	}
	else
	{
		$("#tt_canvas").click(function(){
			tt_view_close();
		});
		
		$("#tt_canvas").show().focus();
		$('#tt_frame').attr('url', uri);
		$('#tt_frame').attr('open', 1);
	}
	
	if(!w)w = 550;
	if(!h)h = 400;
	
	$('#tt_frame').hide();
	$('#tt_frame').css('width', w);
	$('#tt_frame').css('height', h);	
	
	// on choisi la position du parent et on affiche
	pos = $(parentID).position();
	
	margin_top = $(parentID).css('margin-top');
	if(margin_top > 0)pos.top += parseInt(margin_top);
		
	margin_left = $(parentID).css('margin-left');
	if(margin_left > 0)pos.left += parseInt(margin_left);
	
	b_top = $(parentID).css('border-top-width');
	pos.top += parseInt(b_top);
	b_left = $(parentID).css('border-left-width');
	pos.left += parseInt(b_left);		
	
	pos.top -= 85;
	pos.left += 29;	
	
	$('#tt').css({top:pos.top+'px', left:pos.left+'px', width:w+'px', height:h+'px'});
	$("#tt").show();
	$('#tt_frame').load(uri+'&ajax_bloc=content&time='+Math.random(), null, function (_html){																		
																		$(this).show();
															});
}


function tt_form(uri)
{
	$("#tt_canvas").show();
	$("#tt_canvas").click(function(){
			tt_form_close();
	});
	
	$('#ajax_loader').css({top:'50%', left:'50%', zIndex:5558});	
	$('#ajax_loader').show();
	
	
	$('#tt_form_frame').load(uri+'&time='+Math.random(), null, function (){
																				$('#ajax_loader').hide();
																				$(this).show();	
															});
}


function tt_form_close()
{
	$('#tt_form_frame').hide();
	$("#tt_canvas").hide();
	$('#ajax_loader').hide();
}


function tt_delete(delete_msg, delete_url, delete_impossible_msg)
{
	if(delete_impossible_msg != '{delete_impossible_msg}')
	{
		$("#tt_canvas").show();
		alert("Impossible de supprimer cet enregistrement:\n\n  - "+delete_impossible_msg+'\n\n');
		$("#tt_canvas").hide();
		return;
	}	

	$("#tt_canvas").click(function(){
			tt_delete_close();
	});
	$("#tt_canvas").show();	
	
	if(!(c=confirm(delete_msg)))
	{
		tt_delete_close();
	}
	else
	{
		tt_delete_close();
		sys_goto(delete_url, 'DBTable');
	}


}


function tt_delete_close()
{
	$("#tt_canvas").hide();
}


function formHelper(input, type, text)
{
	$(input).focus(function (){
		pos = $(input).position();
		
		// text ?
		//if(type == 'text')
			//pos.top += 30;
		// select ?	
		//if(type == 'select' || type == 'auto_complete')
			pos.top -= 30;
		
		$('#DBTableFormTooltip').css({top:pos.top+'px', left:pos.left+'px'});
		$("#DBTableFormTooltip").html(text);
		$("#DBTableFormTooltip").show('fast');
	});
	
	$(input).blur(function (){
		$("#DBTableFormTooltip").hide('fast');
	});
}