<?php

// include TPLN
include('../../TPLN/TPLN.php');

$TPLN = new TPLN;
$TPLN->DbConnect();


// search treatment
$search = '';
if(isset($_GET['search']) && !empty($_GET['search']))
{
	$search = $TPLN->xssProtect($_GET['search']); # xss protection	
}


$TPLN->Open('Db_showrecords_advanced.html');

// dynamic query
$query = 'SELECT * FROM Country';
if(!empty($search))
{
  
  $search_protected = $TPLN->checkQuotes($search);
  $query .= " WHERE Name LIKE '$search_protected%' ";
  $search = urlencode($search);
  
  $TPLN->UrlAddVar("search=$search");// add search to url
}

$TPLN->SetNavColor('#FFFFFF','#FFFFC0'); // change colors of navigation
$TPLN->ShowRecords($query, 10); // only 10 results by page
$TPLN->DbClose();

$TPLN->Write();



?>