<?php

// include TPLN
include('../../TPLN/TPLN.php');

$TPLN = new TPLN;
$TPLN->Open('Db_showrecords_hook2.html');

$TPLN->DbConnect();
$TPLN->ShowRecords('SELECT * FROM Country ORDER BY RAND()', 10, 'hookData');


// you can hook data before parsing
$Counter = 0;
function hookData($row)
{
	global $TPLN, $Counter;
	
	$row['tr'] = '';
	$row['tr_end'] = '';
	if($Counter == 0)
	{
		$row['tr'] = '<tr>';
	}
	elseif($Counter == 1)
	{
		$row['tr_end'] = '</tr>';
		$Counter = -1; // on reincrement en bas
	}
	$Counter++;
	
	// store resulset index
	$qID = $TPLN->getQueryID();
		
	// ATTENTION !!
	// you can make a subquery but it is a sample just to see in action !
	$sql = "SELECT Language FROM CountryLanguage WHERE CountryCode = '{$row['Code']}'";
	$TPLN->DoQuery($sql);
	
	$langs = array();
	while($row2 = $TPLN->DBFetch())
		$langs[] = $row2['Language'];
	
	$row['Language'] = join(', ', $langs); // create variable count before parsing		
	$row['Count'] = count($langs); // create variable count before parsing
	
	// replace on first resultset
	$TPLN->setQueryID($qID);
	
	
	return $row;
}

$TPLN->DbClose();

$TPLN->Write();




?>